//***************************************************************************************//
//                                   e-BOT Uno                                           //
//                                  e-BOT Maze Sonic                                    //
//                                                                                       //
//                   This enables a bot to avoid obstacles and                           //
//                              may also solve mazes.                                    //
//                                    Codes by:                                          //
//                            e-Gizmo Mechatronix Central                                //
//                             Taft, Manila, Philippines                                 //
//                               http://goo.gl/mNcAUu                                    //
//                                   March 17,2020                                       //
//***************************************************************************************//

// INITIALIZATION:
#include "eGizmo_PBot_Uno.h"
#include <Wire.h>

eGizmo_PBot_Uno PBot;

//US-100 PIN ASSIGNMENT
#define TrigPin 15
#define EchoPin 16
float Distance;
float Point;

int FullSpeed = 80; // SET THE FULL SPEED
int NormalSpeed = 80; // SET THE NORMAL SPEED
int MaxNoDetect = 25; // OBSTACLE DISTANCE DETECTION
int ObstacleDistance = 24;
int ObstacleSense = 23;
int MaxDistanceDetect = 0;
boolean Go = false;
/**********************************************************************************/


void setup()
{
  Serial.begin(9600);
  PBot.BEGIN();

  pinMode(TrigPin,OUTPUT);
  pinMode(EchoPin,INPUT);

}

int ping()
{
  digitalWrite(TrigPin,LOW);
  delayMicroseconds(10);
  digitalWrite(TrigPin,HIGH);
  delayMicroseconds(10);
  digitalWrite(TrigPin,LOW);

  Point = pulseIn(EchoPin,HIGH);
  Distance= Point *0.034/2;
  return(Distance);
}
/**********************************************************************************/
void loop()
{ 
  float Value;
  Value = ping(); // THE Value OF ULTRASONIC
  delay(10);

  // IF THERE IS NO OBSTACLE
  while(Value >= MaxNoDetect)
  {
    PBot.FORWARD(FullSpeed);
    break;
  }
  // IF THERES IS AN OBSTACLE
  while((Value < ObstacleDistance && Value > MaxDistanceDetect)) 
  {
    PBot.STOP(); //IF LESS THAN 24CM, MOTOR STOPS, THEN SEARCHING FOR FREEWAY
    SEARCHING();
    delay(200);
    break;
  }
  PBot.SERVO1(90);

}

/*---------------------------*/
void SEARCHING()
{
  int OppentOnLeft;
  int OpponentOnCenter;
  int OpponentOnRight;

  PBot.SERVO1(10);
  delay(500);
  OpponentOnRight = ping();


  PBot.SERVO1(170);
  delay(500);
  OppentOnLeft = ping();

  PBot.SERVO1(90);
  delay(500);
  OpponentOnCenter= ping();

  /*---------------------------*/
  if(OpponentOnRight < ObstacleDistance )
  {
    PBot.STOP();  
    Go = true;
    if(OpponentOnRight < ObstacleSense && Go== true){
      PBot.SPINLEFT(FullSpeed);
      delay(800); 
      PBot.FORWARD(FullSpeed);  
      delay(500);
      Go = false;
    }
  }
  /*---------------------------*/
  else if(OppentOnLeft < ObstacleDistance)
  { 
    PBot.SPINRIGHT(FullSpeed);
    delay(800);
    PBot.FORWARD(FullSpeed);                                      
    delay(500);
  }
  /*---------------------------*/
  else if(OppentOnLeft = OpponentOnRight)
  {
    PBot.REVERSE(NormalSpeed);
    delay(400);
    PBot.SPINRIGHT(FullSpeed);
    delay(100);
  }
}

// Program Ends
















